use strict;
use Template;
use CGI qw(:standard);

$ENV{'HOME'} = "/home/httpd/htdocs/pronto/";

our $session_timeout = 600;

use lib "/home/httpd/htdocs/pronto";
use lib "/home/httpd/htdocs/pronto/web";
use lib "/usr/local/lib/pronto";
require "/usr/local/lib/pronto/prontolib.pl";

our($conn, %prefs, $template);

&read_prefs();
$conn = &open_db_conn;
$template = new Template({INCLUDE_PATH => "/home/httpd/htdocs/pronto/web/templates",
			  POST_CHOMP => 1});

&check_session unless $main::no_session_check;

sub check_session {
  my $valid_till = time() + $session_timeout;

  # Make sure that our session isn't expired
  if (!(param('session') =~ /^[0-9]+$/)) {html_die("No session ID transmitted.");}
  my $sth = $conn->prepare("SELECT session,IP from web_session WHERE session = " . param('session') . " AND valid_till > " . time()) || die $conn->errstr;
  $sth->execute() || die $conn->errstr;
  my ($session, $ip) = $sth->fetchrow();
  if (!defined $session) {
    html_die("Your session is no longer valid.");
  }
  elsif ($session != param('session')) {
    html_die("Your session is no longer valid.");
  }
  elsif (!($ip eq $ENV{'REMOTE_ADDR'})) {
    html_die("Your IP and the given session do not fit.");
  }

  # Update the timestamp that the user doesn't run out of time
  my $sql = "UPDATE web_session SET valid_till = " . (time()+$session_timeout) . " WHERE session = " . param('session') . " AND valid_till > " . time();
  my $affected_rows = $conn->do($sql);
  if (!defined $affected_rows) {
    die $sql . ": " . $conn->errstr;
  }
 # elsif ($affected_rows == 0) {
    #html_die("I couldn't update your session timestamp.");
 # }
}

sub html_die {
  my $message = shift;

  eval { #we must not die in this function => recursion
    print header, start_html(-BGCOLOR=>'#425C7D', "Error"), "<h1>An error occured</h1>\n<b>$message</b>", end_html;
    exit 1;
  };
  if ($@) {
    print STDERR $@;
    exit 1;
  }
}

sub get_win_size {
        my ($name,$dw,$dh) = @_;
        
        return ($dw,$dh) unless $prefs{'saveSize'} eq "y";
        return ($dw,$dh) unless defined $prefs{$name.'Width'} and
                            defined $prefs{$name.'Height'} >0;
        return ($prefs{$name.'Width'},
                $prefs{$name.'Height'});

}

sub set_clist_drag_signals
{       
        return;
}


END {
  $conn->disconnect() if $conn;
}

1;
