package HTMLWidget::MessageView;
use strict;

sub new {
  my $class = shift;
  my ($to, $from, $date, $subject, $cc, $message);

  my $self = {attachment => [], boxname => [], boxid => []};

  return bless $self, $class;
}

sub insert {
  my ($self, $font, undef, undef, $body) = @_;
  $self->{body} = $body;
}

sub quote {
  my $s = shift;

  $s =~ s/</&lt;/g;
  $s =~ s/>/&gt;/g;
  return $s;
}

sub draw {
  my $self = shift;
  my @attachments;
  my @folders;
  my $haveattachment;

  $self->{from} = &quote($self->{from});
  $self->{to}   = &quote($self->{to});
  $self->{cc}   = &quote($self->{cc});
  $self->{subject} = &quote($self->{subject});
  $self->{date} = &quote($self->{date});

  for (my $i = 0; $i < @{$self->{attachment}}; $i++) {
    push @attachments, $self->{attachment}->[$i];
    $haveattachment = 1;
  }

  for (my $i = 0; $i < @{$self->{boxlist}}; $i+=2) {
    push @folders, " <option value=".$self->{boxlist}->[$i+1]."> ".$self->{boxlist}->[$i];
  }

  $self->{template}->process("view.html", {body => $self->{body},
					from => $self->{from},
					to   => $self->{to},
					cc   => $self->{cc},
					subject => $self->{subject},
					date => $self->{date},
					message => $self->{message},
					attachments => \@attachments,
					haveattachment => $haveattachment,
					folders => \@folders });
}

sub AUTOLOAD {
}

1;
