package Search;
use strict;

use Gtk::CList;
use Pronto::MessageList;
use Pronto::FolderTree;
use Gtk::Dummy;
use HTMLWidget::FolderTree;
use Gtk::Gdk::Pixmap;
use Gtk::Pixmap;
use CGI qw(:standard);

sub searchwin {
	my $session = shift;
	my $sql = "select name,id from boxlist order by id";
	my $query=$main::conn->prepare($sql);
	$query->execute() || die $query->errstr;
	my @boxes;
	while (my ($name, $id) = $query->fetchrow_array()) {
		if (($id>0) && ($id<1000)) {
    			push @boxes, "<option value=$id> $name";
		}
	}
	print header;
	$main::template->process("search.html", {session => $session,
		boxlist => \@boxes}) || die $main::template->error();
}

sub process {
	my $session = shift;
	my $subject = shift;
	my $from    = shift;
	my $body    = shift;
	my $box     = shift;
	my $limit   = shift;
	our ($folder_tree, %ft_id, $root_window);

	$main::prefs{WebPixmapDir} = "/pronto/pixmaps";

	# Prepare the clist

	Pronto::MessageList->make_clist();
	Pronto::MessageList->make_clist_sigs;
	$main::message_clist->{template} = $main::template;
	$main::message_clist->{title} = "Search results";
	bless $main::message_clist, "Gtk::CList";

	# Set the pixmaps

	my ($paperclip,$paperclip_mask,$exclamation,$exclamation_mask,$replyf,$replyf_mask,$forwardf,$forwardf_mask,$newm,$newm_mask);

	if(-f "$main::prefs{'PixmapDir'}/paperclip.xpm") {
		($paperclip,$paperclip_mask)=Gtk::Gdk::Pixmap->create_from_xpm($main::message_clist->clist_window,$main::message_clist->style->bg('normal'),"$main::prefs{'PixmapDir'}/paperclip.xpm");
	}
	else {
		($paperclip,$paperclip_mask)=Gtk::Gdk::Pixmap->create_from_xpm_d($main::message_clist->clist_window,$main::message_clist->style->bg('normal'),@main::dummy_pixmap);
	}
	if(-f "$main::prefs{'PixmapDir'}/exclamation.xpm") {
		($exclamation,$exclamation_mask)=Gtk::Gdk::Pixmap->create_from_xpm($main::message_clist->clist_window,$main::message_clist->style->bg('normal'),"$main::prefs{'PixmapDir'}/exclamation.xpm");
	}
	else {
		($exclamation,$exclamation_mask)=Gtk::Gdk::Pixmap->create_from_xpm_d($main::message_clist->clist_window,$main::message_clist->style->bg('normal'),@main::dummy_pixmap);
	}
	if(-f "$main::prefs{'PixmapDir'}/reply_flag.xpm") {
		($replyf,$replyf_mask)=Gtk::Gdk::Pixmap->create_from_xpm($main::message_clist->clist_window,$main::message_clist->style->bg('normal'),"$main::prefs{'PixmapDir'}/reply_flag.xpm");
	}
	else {
		($replyf,$replyf_mask)=Gtk::Gdk::Pixmap->create_from_xpm_d($main::message_clist->clist_window,$main::message_clist->style->bg('normal'),@main::dummy_pixmap);
	}
	if(-f "$main::prefs{'PixmapDir'}/forward_flag.xpm") {
		($forwardf,$forwardf_mask)=Gtk::Gdk::Pixmap->create_from_xpm($main::message_clist->clist_window,$main::message_clist->style->bg('normal'),"$main::prefs{'PixmapDir'}/forward_flag.xpm");
	}
	else {
		($forwardf,$forwardf_mask)=Gtk::Gdk::Pixmap->create_from_xpm_d($main::message_clist->clist_window,$main::message_clist->style->bg('normal'),@main::dummy_pixmap);
	}
	if(-f "$main::prefs{'PixmapDir'}/newm.xpm") {
		($newm,$newm_mask)=Gtk::Gdk::Pixmap->create_from_xpm($main::message_clist->clist_window,$main::message_clist->style->bg('normal'),"$main::prefs{'PixmapDir'}/newm.xpm");
	}
	else {
		($newm,$newm_mask)=Gtk::Gdk::Pixmap->create_from_xpm_d($main::message_clist->clist_window,$main::message_clist->style->bg('normal'),@main::dummy_pixmap);
	}

	# Do the query

	my $sql = "SELECT id,friendly,subject,date,newmsg,localdate,contenttype,priority,replyf,score FROM messages WHERE ";
	if ($body ne "") {
		$sql = "SELECT messages.id,friendly,subject,date,newmsg,localdate,contenttype,priority,replyf,score FROM messages LEFT JOIN message_sources ON messages.id=message_sources.id WHERE ";
	}

	if ($subject ne "_foo_") { $sql = $sql . "subject like \"%".$subject."%\" AND "; }
	if ($from ne "_foo_" ) { $sql = $sql . "friendly like \"%".$from."%\" AND "; }
	if ($body ne "_foo_" ) { $sql = $sql . "bodytext like \"%".$body."%\" AND "; }
	if ($box ne "_foo_" ) { $sql = $sql . "boxid = ".$box." AND "; }
	$sql =~ s/AND $//;
	if ($limit ne "_foo_") { 
		if ($limit =~ /[A-Za-z]/) {
			&main::html_die('"Limit" needs a numerical value');
		}
		$sql = $sql . " LIMIT ".$limit; 
	}

	my $query = $main::conn->prepare($sql);
	$query->execute() || die $query->errstr;

	# Create the messages list

	my $rows = $query->rows;
	my $row = 0;
	while (my @row=$query->fetchrow_array) {		       
		if (not defined $row[9]) { $row[9] = 0; }
		if ($row[9] == 0) { $row[9] = " "; }
		
		if (defined $row[10] && $row[10] == 1) { 
			$row[10] = "Not Fetched"; 	# Message is still on server and has NOT been fetched.
							# 
		} elsif (defined $row[10] && ($row[10] == 2 || $row[10] == 6)) { 
			$row[10] = "On Server" # Message is still on server and has been fetched. 
						#
		} elsif (defined $row[10] && $row[10] == 3) { 
			$row[10] = "To Be Deleted"; 	# Message is flagged for deletion. 
							#
		} elsif (defined $row[10] && $row[10] == 4) { 
			$row[10] = "To Be Fetched & Deleted"; 	# Message is flagged for deletion. 
								#
		} else { 
			$row[10] = " "; # Message is not on server.
					#
		}

		$main::message_clist->insert($row,'','','',$row[9],$row[1],$row[2],&main::localdate_to_displaydate($row[5]),$row[10],$row[5]);
		if ($row[6] && ($row[6] !~ /text/i && $row[6] !~ /alternative/i && $row[6] !~ /multipart\/report/i)) {
			$main::message_clist->set_pixmap($row, 1, $paperclip, $paperclip_mask);
		}
		if (($row[7]) and ($row[7] =~ /high/i)) {
			$main::message_clist->set_pixmap($row, 0, $exclamation, $exclamation_mask);
		}
		if ($row[8]) {
			if ($row[8] == 1) {
				$main::message_clist->set_pixtext($row, 4, $row[1],1,$replyf, $replyf_mask);
			} elsif ($row[8] == 2) {
				$main::message_clist->set_pixtext($row, 4, $row[1],1,$forwardf, $forwardf_mask);
			}
		}
		if (($row[4]) and ($row[4] eq "y")) {
			$main::message_clist->set_pixmap($row, 2, $newm, $newm_mask);
			if ($main::prefs{'BoldMsg'}) {
				$main::message_clist->set_row_style($row,2);
			}	
		} else {
			if ($main::prefs{'BoldMsg'}) {
				$main::message_clist->set_row_style($row,1);
			}	
		}
		$main::message_clist->set_row_data($row, \$row[0]);
		$row++;
	}

	# Get all folders where messages can be moved to
	my $sql = "select name,id from boxlist order by id";
	$query=$main::conn->prepare($sql);
	$query->execute() || die $query->errstr;
	my @boxes;
	while (my ($name, $id) = $query->fetchrow_array()) {
		if (($id>0) && ($id<1000) && ($id!=$main::ft_id{selected})) {
			push @boxes, ($name, $id);
		}
	}
	$main::message_clist->{boxlist} = \@boxes;

	# Print the list
	print header;
	$main::message_clist->draw($session);
}

sub set_labels {
  return;
}

sub set_win_title {
  return;
}

1;
