package SendWin;
use strict;

use lib "/home/httpd/htdocs/pronto/web";
use Pronto::Data::Message;
use Pronto::Send;
use MIME::Entity;
use Pronto::Read;
use HTMLWidget::MessageView;
use Gtk::Dummy;
use MIME::Parser;
use Pronto::Link;
use CGI qw(:standard);

sub justsend {
	&send_out();
	print header;
}

sub reply_forward {
	my $action  = shift;
	my $message = shift;
	my $session = shift;
	my $title;
	my $extrafield;
	our ($view_widget, $parser);
	$parser = new MIME::Parser;
	$parser->output_dir("$main::prefs{'MailDir'}/tmp/");
	our $HTMLWIDGET = "text";
	$view_widget = new HTMLWidget::MessageView();
	$view_widget->{message} = $message;

	# Get the header information
	my $sql = "select sentfrom,subject,cc from messages where id= '".$message."'";
	my $query=$main::conn->prepare($sql);
	$query->execute() || die $query->errstr;
	my ($from, $subject, $cc) = $query->fetchrow_array();

	# Don't confuse the form with any '"'
	$from    =~ s/"/&quot;/g;
	$subject =~ s/"/&quot;/g;
	$cc      =~ s/"/&quot;/g;

	# Here's the only difference between 'reply' and 'forward'
	if ($action eq "reply") {
		&Pronto::Read::view_message($main::conn, $message, $view_widget, 2, 1, undef, undef, undef, undef, undef, undef);
		$view_widget->{subject} = $subject;
		if (!($subject =~ /^Re: /i)) {
			$view_widget->{subject} = "Re: $subject";
		}
		$title = "Reply message";
		$view_widget->{from} = $from;
		$view_widget->{cc}   = $cc;
		$extrafield = "<input type=\"hidden\" name=\"refto\" value=\"".$message."\">\n";
		$extrafield.= " <input type=\"hidden\" name=\"forrep\" value=\"1\">\n";
	} else {
		&Pronto::Read::view_message($main::conn, $message, $view_widget, 2, 2, undef, undef, undef, undef, undef, undef);
		$view_widget->{subject} = $subject;
		if (!($subject =~ /^Fwd*: /i)) {
			$view_widget->{subject} = "Fwd: $subject";
		}
		$title = "Forward message";
		$view_widget->{from} = "";
		$view_widget->{cc}   = "";
		$extrafield = "";
		$extrafield = "<input type=\"hidden\" name=\"refto\" value=\"".$message."\">\n";
		$extrafield.= " <input type=\"hidden\" name=\"forrep\" value=\"2\">\n";
	}

	my @accounts = &get_accounts();

	print header;
	$main::template->process("compose.html", {
		session => $session,
		title => $title,
		accounts => \@accounts,
		body => $view_widget->{body},
		subject => $view_widget->{subject},
		to => $view_widget->{from},
		extrafield => $extrafield }) || die $main::template->error();
}

sub compose {
	my $session = shift;
	my @accounts = &get_accounts();

	print header;

	$main::template->process("compose.html", {
		session => param('session'),
		title => "Compose new message",
		accounts => \@accounts }) || die $main::template->error();
}

sub send {
	my $refto    = shift; $refto  = "" if ($refto  eq "foo");
	my $forrep   = shift; $forrep = "" if ($forrep eq "foo");
	my $body     = shift;
	my $to       = shift;
	my $cc       = shift; $cc     = "" if ($cc     eq "foo");
	my $bcc      = shift; $bcc    = "" if ($bcc    eq "foo");
	my $subject  = shift;
	my $acctid   = shift;
	my $attached = shift;

	my @attachments;
	my $parsed_in_refto = undef;
	my $parsed_forrep = undef;
	if ($refto  ne "") { $parsed_in_refto = $refto; }
	if ($forrep ne "") { $parsed_forrep   = $forrep; }

	# Get the attachments and store them temporarily
	if ($attached ne "") {
#		my $buffer;
		my $filename = $main::prefs{'MailDir'}."/tmp/".$attached;
#		open (OUTFILE,">>$filename");
#		while (my $bytesread=read($attached,$buffer,1024)) {
#			print OUTFILE $buffer;
#		}

		push @attachments, $filename;
	}

	# Get rid of the \r at the end of a line
	(my $parsed_body = $body) =~ s/\r//g;

	# Send the mail
	&Pronto::Data::Message::send_message(undef, undef, $parsed_in_refto, $parsed_forrep, $parsed_body, "unknown\@sender.org", $to, $cc, $bcc, $subject, $acctid, \@attachments);

	# delete stored attachments again
	foreach my $filename (@attachments) {
		unlink($filename);
	}

	print header, start_html(-script=> "opener.location.reload();\nself.close();"), end_html; 
}

#
# Sends all messages that currently are in the outbox
#
sub send_out {
	#if copy of prontosend running then stop
	if (open(TMP,"<$main::prefs{'MailDir'}/prontosend.running")) { 
		my $proc = <TMP>;
		if(kill (0,$proc)) {
			html_die("Prontosend is already running. if this is not true, please delete\n
			prontosend.running in " . $main::prefs{'MailDir'} );
			exit;
		}
		else {
			close(TMP);
			unlink "$main::prefs{'MailDir'}/prontosend.running";
		}
	}

	$Pronto::Send::inter = 0;            # no this isn't an Gtk interactive session
	$Pronto::Send::called_from_send = 0; # if set to 1 the db connection would be closed
	&Pronto::Send::send();
}	

#
# Returns a list of all accounts for a html <select> form
#
sub get_accounts {
	my $sql = "select id,descr,def from accounts";
	my $query=$main::conn->prepare($sql);
	$query->execute() || die $query->errstr;
	my @accounts;;
	while (my ($id, $descr, $def) = $query->fetchrow_array()) {
    		if ($def ne "y") {
			push @accounts, "<option value=$id> $descr";
		} else {
			push @accounts, "<option selected value=$id> $descr";
		}
	}
	return @accounts;
}

sub address_win {
	print header;
	my $sql = "SELECT alias, address FROM addresses ORDER BY alias";
	my $query=$main::conn->prepare($sql);
	$query->execute() || die $query->errstr;

	my @mailaddr;
	while (my ($alias, $address) = $query->fetchrow_array()) {
		my $string = qq!&quot;$alias&quot; &lt;$address&gt;!;
		push @mailaddr, "<option value=\"$string\"> $alias\n";
	}

	$main::template->process("address.html", {
		mailaddr => \@mailaddr }) || die $main::template->error();
}

1;
