package View;

use strict;
use Pronto::Read;
use lib "/home/httpd/htdocs/pronto/web";
use Pronto::Data::Message;
use HTMLWidget::MessageView;
use Gtk::Dummy;
use Pronto::Link;
use CGI qw(:standard);

sub viewit {
	my $message = shift;
	our $view_widget;

	# Delete old entries in the tmp dir
#	opendir(DIR,"$main::prefs{'MailDir'}/tmp");
#	while (defined (my $nuke = readdir DIR)) {
#		next if $nuke =~ /^\..*$/;
#		unlink "$main::prefs{'MailDir'}/tmp/$nuke";
#	}
#	closedir(DIR);

	$main::parser->output_dir("$main::prefs{'MailDir'}/");
	$main::parser->output_dir("$main::prefs{'MailDir'}/tmp/");

	if (!$message) {
	  print header;
	  print start_html(-BGCOLOR=>'#D0D0D0', "No Message selected");
	  print h1("No Message selected");
	  print end_html;
	  exit 0;
	}

	if (!defined $view_widget) {$view_widget = new HTMLWidget::MessageView();}
	$view_widget->{template} = $main::template;
	$view_widget->{message} = $message;

	# Get the body
	&Pronto::Read::view_message($main::conn, $message, $view_widget, 1, 4, undef, undef, undef, undef, undef, undef);

	# Get the header information
	my $sql = "select sentfrom, sentto, date, subject,cc,contenttype from messages where id= '$message'";
	my $query=$main::conn->prepare($sql);
	$query->execute() || die $query->errstr;
	my ($from, $to, $date, $subject, $cc, $ct) = $query->fetchrow_array();

	$view_widget->{to}      = $to;
	$view_widget->{from}    = $from;
	$view_widget->{date}    = $date;
	$view_widget->{subject} = $subject;
	$view_widget->{cc}      = $cc;

	# Write the body without the <body> and <html> tags
	#my $tmpfile = "$main::prefs{'MailDir'}/file.html";
	#open (DUMP,"<$tmpfile");
	#foreach my $line (<DUMP>) {
	#	$line =~ s/<\/*(body|html).*?>//;
	#	$line =~ s/src=\"\/home\/httpd\/htdocs/src=\"/g;
	#	$view_widget->{body} .= $line
	#}
	#close(DUMP);
	$view_widget->{body} =~ s/src=\"\/home\/httpd\/htdocs/src=\"/g;
	$view_widget->{body} =~ s/<\/*(html|body).*?>//g;

	# Collect all possible attachments
	opendir(DIR,"$main::prefs{'MailDir'}/tmp");
	my @attachments;
	while (defined (my $file = readdir DIR)) {
		next if (($file =~ /^\..*$/) || ($file =~/^(msg-.*(txt|html)|dump)/));
		push @attachments, $file;
	}
	closedir(DIR);
	$view_widget->{attachment} = \@attachments;

	# Get all folders where messages can be moved to
	$sql = "select name,id from boxlist order by id";
	$query=$main::conn->prepare($sql);
	$query->execute() || die $query->errstr;
	my @boxes;
	while (my ($name, $id) = $query->fetchrow_array()) {
		if (($id>0) && ($id<1000)) {
			push @boxes, ($name, $id);
		}
	}
	$view_widget->{boxlist} = \@boxes;

	print header;

	$view_widget->draw();
}

1;
